
#ifndef CNOID_GUIBASE_OSG_VIEWER_H_INCLUDED
#define CNOID_GUIBASE_OSG_VIEWER_H_INCLUDED

#include <osgViewer/Viewer>
#include <QGLWidget>
#include "exportdecl.h"

namespace cnoid {

    class CNOID_EXPORT OSGWidget : public QGLWidget
    {
        osg::ref_ptr<osgViewer::GraphicsWindowEmbedded> graphicsWindow_;
        
    public:
        OSGWidget(QWidget* parent = 0, const QGLWidget* shareWidget = 0, Qt::WindowFlags f = 0);
        virtual ~OSGWidget();

        inline osgViewer::GraphicsWindow* graphicsWindow() {
            return graphicsWindow_.get();
        }
        inline const osgViewer::GraphicsWindow* graphicsWindow() const {
            return graphicsWindow_.get();
        }

        static int convertToOSGmouseButtonMask(int qtButton);
        static int convertToOSGkeySymbol(int qtKeySymbol);
        static int convertToOSGmodKeyMask(int qtModifiers);
        static int convertToOSGscrollingMotion(QWheelEvent* event);

    protected:
        virtual void resizeGL(int width, int height);
    };


    class CNOID_EXPORT OSGViewer : public osgViewer::Viewer, public OSGWidget
    {
      public:
        OSGViewer(QWidget* parent = 0, const QGLWidget* shareWidget = 0, Qt::WindowFlags f = 0);
        virtual ~OSGViewer();

        virtual void requestRedraw();
        virtual void paintGL();

        /// temorary hack
        inline bool isCollisionVisibleMode() { return isCollisionVisibleMode_; }

      private:
        bool isCollisionVisibleMode_;
        friend class SceneViewImpl;
    };
}

#endif
